// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/ods"
	model "LAPP_LF_MOM_BACKEND/models/ods"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ArtRouteOdsLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ArtRouteOdsLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 12:11:47
 *
 ******************************************************************************/
type ArtRouteOdsLstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewArtRouteOdsLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ArtRouteOdsLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : ArtRouteOdsLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-19 12:11:47
 *
 ******************************************************************************/
func NewArtRouteOdsLstDAOImplement(session *xorm.Session, plantNr int, userid string) *ArtRouteOdsLstDAOImplement {
	return &ArtRouteOdsLstDAOImplement{session, &meta.ArtRouteOdsLst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) InsertOne(entity *model.ArtRouteOdsLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) DeleteOne(artId string, operationNr int, pos int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, artId, operationNr, pos}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) SelectOne(artId string, operationNr int, pos int) (*model.ArtRouteOdsLst, error) {
	var data model.ArtRouteOdsLst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, artId, operationNr, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.SelectOneByWorkPlaceId
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) SelectOneByWorkPlaceId(artId string, workPlaceNr int) (*model.ArtRouteOdsLst, error) {
	var data model.ArtRouteOdsLst
	ok, err := impl.session.Table(meta.ArtRouteOdsLst.TableName).Where("PlantNr = ? and ArtId = ? and WorkPlaceNr = ?", impl.plantNr, artId, workPlaceNr).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) UpdateOne(entity *model.ArtRouteOdsLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.Insert
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) Insert(entities *[]model.ArtRouteOdsLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.Delete
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) Delete(entities *[]model.ArtRouteOdsLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtRouteOdsLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.Select
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ArtRouteOdsLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtRouteOdsLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.ArtRouteOdsLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ArtRouteOdsLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtRouteOdsLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.ArtRouteOdsLst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ArtRouteOdsLst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.Update
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) Update(entities *[]model.ArtRouteOdsLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ArtRouteOdsLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.ArtRouteOdsLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.ArtRouteOdsLst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/ods/ArtRouteOdsLstDAO.SelectByArtId
 *
 ******************************************************************************/
func (impl *ArtRouteOdsLstDAOImplement) SelectByArtId(artId string) ([]model.ArtRouteOdsLst, error) {

	data := make([]model.ArtRouteOdsLst, 0)
	err := impl.session.Table(impl.meta.TableName).Where("PlantNr = ? and ArtId = ?",impl.plantNr,artId).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}